package de.snailshell.consensus.demo.actions;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import de.snailshell.consensus.demo.Constants;
import de.uka.ipd.consensus.foundation.ontology.OntologyManager;
import de.uka.ipd.consensus.foundation.schema.Topic;
import de.uka.ipd.consensus.foundation.schema.User;

/**
 * @author Thomas Much
 * @version 2006-06-14
 */
public class AddTypeAction extends BasisAction {

	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {

		if (!isUserLoggedOn(request)) {
			return mapping.findForward( Constants.MAPPING_FAILURE );			
		}

		OntologyManager om = this.getOntologyManager();

		User user = this.getUser( request );
		
		String id    = request.getParameter( "id" );
		String typid = request.getParameter( "typid" );

		Topic t    = om.getQueryEngine().getTopicById( user, id );
		Topic type = om.getQueryEngine().getTopicById( user, typid );
		
		t.addType( user, type );

		return mapping.findForward( Constants.MAPPING_SUCCESS );
	}
}
